//this file is part of eMule IS Mod
//Copyright (C)2009 eMule IS Mod
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include <wininet.h>
#include <atlutil.h>
#include "sctupd.h"

BEGIN_MESSAGE_MAP(CSctUpdApp, CWinApp)
END_MESSAGE_MAP()

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CMemFile* DownloadFile ( LPCTSTR szURL );

CSctUpdApp::CSctUpdApp()
{
    iExitCode = 0;
}

CSctUpdApp theApp;


// argc[1] - file url
// argc[2] - path to write
BOOL CSctUpdApp::InitInstance()
{
    CWinApp::InitInstance();
    
    int argc;
    LPWSTR *argv = CommandLineToArgvW(GetCommandLineW(), &argc);
    if ( argc < 3 )
    {
        iExitCode = 1;
        return FALSE;
    }

    LPCTSTR szCurDllPath = argv[2];
    CMemFile* pMemFile = DownloadFile(argv[1]);
    if ( pMemFile == NULL )
    {
        iExitCode = 1;
        return FALSE;
    }

    CString strNewDllPath;
    strNewDllPath.Format(_T("%s.new"), szCurDllPath);
    CString strOldDllPath;
    strOldDllPath.Format(_T("%s.old"), szCurDllPath);

    //   
    CFile newDllFile;

    if ( newDllFile.Open(strNewDllPath, CFile::modeWrite|CFile::modeCreate|CFile::shareExclusive) == FALSE )
    {
        iExitCode = 1;
        return FALSE;
    }

    BYTE tmpBuf[500];
    int iReadCount;
    pMemFile->Seek(0, CFile::begin);

    while( (iReadCount = pMemFile->Read(tmpBuf, _countof(tmpBuf))) > 0 )
    {
        newDllFile.Write(tmpBuf, iReadCount);
    }
    delete pMemFile;

    newDllFile.Close();

    //   
    if ( MoveFileEx(szCurDllPath, strOldDllPath, MOVEFILE_REPLACE_EXISTING) == FALSE )
    {
        iExitCode = 1;
        return FALSE;
    }

    //   
    if ( MoveFileEx(strNewDllPath, szCurDllPath, MOVEFILE_REPLACE_EXISTING) == FALSE )
    {
        //   
        MoveFileEx(strOldDllPath, szCurDllPath, MOVEFILE_REPLACE_EXISTING);
        iExitCode = 1;
        return FALSE;
    }

    return TRUE;
}

CMemFile* DownloadFile ( LPCTSTR szURL )
{
    //  WinInet
    HINTERNET hInternet = InternetOpen(_T("SCT"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);

    if (!hInternet)
        return NULL;


    //  HTTP 
    CUrl url;
    url.CrackUrl(szURL, ATL_URL_DECODE);
    HINTERNET hConnect = InternetConnect(
        hInternet,
        url.GetHostName(),
        url.GetPortNumber(),
        NULL,NULL,
        INTERNET_SERVICE_HTTP,
        0,
        NULL);

    if (!hConnect)
    {
        InternetCloseHandle(hInternet);
        return NULL;
    }

    //  
    HINTERNET hRequest = HttpOpenRequest(hConnect, _T("GET"), url.GetUrlPath(), NULL,
        NULL, 0, NULL, 0);

    if (!hRequest)
    {
        InternetCloseHandle(hInternet);
        return NULL;
    }

    BOOL bSend = HttpSendRequest(hRequest, NULL,0, NULL,0);
    if (!bSend)
    {
        InternetCloseHandle(hInternet);
        return NULL;
    }

    TCHAR szStatusCode[MAX_PATH];
    DWORD dwStatusCodeSize = _countof(szStatusCode);
    DWORD dwInfoIndex = 0;
    if( !HttpQueryInfo(hRequest, HTTP_QUERY_STATUS_CODE, &szStatusCode, &dwStatusCodeSize, &dwInfoIndex))
	{
		InternetCloseHandle(hInternet);
        return NULL;
	}
    if ( lstrcmp(szStatusCode, _T("200")) != 0 )
	{
		InternetCloseHandle(hInternet);
        return NULL;
	}
    
    //   
    CMemFile *pFile = new CMemFile;

    BYTE pTempData[500];
    DWORD dwBytesRead;

    do
    {
        InternetReadFile( hRequest, (LPVOID)pTempData, _countof(pTempData), &dwBytesRead);
        pFile->Write(pTempData, dwBytesRead);
    }while(dwBytesRead);

	InternetCloseHandle(hInternet);

    return pFile;
}

int CSctUpdApp::ExitInstance()
{
    CWinApp::ExitInstance();

    return iExitCode;
}
