//this file is part of eMule IS Mod
//Copyright (C)2009 IS Mod Team
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "Authorization.h"
#include "AuthDlg.h"
#include "EmuleDlg.h"
#include "menucmds.h"
#include "Log.h"
#include "Preferences.h"
#include "CBase64Coding.hpp"
#include "StringConversion.h"
#include "emule.h"
#include "version.h"
#include <OpenSSL/engine.h>
#include <OpenSSL/ssl.h>
#include <OpenSSL/err.h>
#include <tinyxml/tinyxml.h>
//#pragma warning(disable:4516) // access-declarations are deprecated; member using-declarations provide a better alternative
#pragma warning(disable:4244) // conversion from 'type1' to 'type2', possible loss of data
#pragma warning(disable:4100) // unreferenced formal parameter
//#pragma warning(disable:4702) // unreachable code
//#pragma warning(disable:4127)
#pragma warning(disable:4706) // conversion from 'type1' to 'type2', possible loss of data
#pragma warning(disable:4189) // local variable is initialized but not referenced
#include <cryptopp/blowfish.h>
#include <cryptopp/base64.h>
#include <cryptopp/files.h>
//#include <cryptopp/filters.h>
#include <cryptopp/modes.h>
#include <cryptopp/gzip.h>
//#include <cryptopp/osrng.h>
//#include <cryptopp/hex.h>
//#include <cryptopp/modes.h>
//#include <cryptopp/aes.h>
//#include <cryptopp/des.h>
#include <cryptopp/md5.h>
#pragma warning(default:4189) // local variable is initialized but not referenced
#pragma warning(default:4706) // conversion from 'type1' to 'type2', possible loss of data
//#pragma warning(default:4702) // unreachable code
#pragma warning(default:4100) // unreferenced formal parameter
#pragma warning(default:4244) // conversion from 'type1' to 'type2', possible loss of data
//#pragma warning(default:4516) // access-declarations are deprecated; member using-declarations provide a better alternative

AuthProcess theAuth;

//           :-)
//    ,    
void convert_number(int number, byte *array, int len_array){
	const int SHIFT = 5;
	union {
		unsigned int i; 
		unsigned char c[sizeof(int)];
	} diget;

	int tmpNumber = number;
	int countArray = 0;

	//      sizeof(int)
	for(UINT i=0; i < len_array/sizeof(int); i++){
		//      ,   
		diget.i = tmpNumber^((tmpNumber<<SHIFT)+i)&((tmpNumber<<(SHIFT*2))+i)|((tmpNumber<<(SHIFT*3))+i);
		tmpNumber = diget.i;
		for(int j=0; j<sizeof(int); j++){
			array[countArray++] = diget.c[j];
		}
	}
	
	//  
	diget.i = tmpNumber^(tmpNumber<<SHIFT)^(tmpNumber<<SHIFT*2);
	for(UINT i=0; i<len_array%sizeof(int); i++){
		array[countArray++] = diget.c[i%sizeof(int)];
	}
}

//  
void CreateKey(byte *key, int len_key){
	memset( key, 0x00, len_key );

	//     
	wchar_t NameBuffer[MAX_PATH];
	wchar_t SysNameBuffer[MAX_PATH];
	DWORD VSNumber;
	DWORD MCLength;
	DWORD FileSF;

	//  
	if (!GetVolumeInformation(L"C:\\",NameBuffer, sizeof(NameBuffer),
			&VSNumber,&MCLength,&FileSF,SysNameBuffer,sizeof(SysNameBuffer))){
		VSNumber = 1024; //        ,    
	}

	//      
	convert_number(VSNumber, key, len_key);
}

//     
void CreateIV(byte *src, int len_src, byte *iv, int len_iv){
	memset( iv, 0x00, len_iv );

	for(int i=0; i<len_iv; i++){
		iv[i] = src[i%len_src];
	}
}

//     AES
//       (  )  
CString AuthProcess::EncryptPasswd(const CString &passwd, const CString &nameFile)
{
	using namespace CryptoPP;
	using namespace std;

	#define MAX_NUMBER_IN_FILE 10

	// 
	string spasswd = (string)StrToUtf8(passwd);
	string snameFile = (string)StrToUtf8(nameFile);

	//     
	srand((UINT)time(NULL));
	fstream rand_file(snameFile.c_str(),ios::out|ios::trunc);
	for(int i=0;i<MAX_NUMBER_IN_FILE;i++){
		rand_file<<rand();
	}
	rand_file.close();

	//   
	CryptoPP::Weak::MD5 hash;
	byte hashFile[CryptoPP::Weak::MD5::DIGESTSIZE]; //output size of the buffer
 
	try{
		CryptoPP::FileSource f(snameFile.c_str(), true,
                new CryptoPP::HashFilter(hash,new CryptoPP::ArraySink(hashFile,CryptoPP::Weak::MD5::DIGESTSIZE)));
	}catch(...){
		memset( hashFile, 0x01, CryptoPP::Weak::MD5::DIGESTSIZE );
	}
	
	// Key and IV setup
    byte key[ CryptoPP::Blowfish::DEFAULT_KEYLENGTH ],iv[ CryptoPP::Blowfish::BLOCKSIZE ];
    // 
	CreateKey( key, CryptoPP::Blowfish::DEFAULT_KEYLENGTH);
	CreateIV(hashFile, CryptoPP::Weak::MD5::DIGESTSIZE, iv, CryptoPP::Blowfish::BLOCKSIZE);

	std::string cipher;
    {
        CryptoPP::StringSink* sink = new CryptoPP::StringSink(cipher);
        CryptoPP::Base64Encoder* base64_enc = new CryptoPP::Base64Encoder(sink);
        CryptoPP::CBC_Mode<CryptoPP::Blowfish>::Encryption twofish(key, CryptoPP::Blowfish::DEFAULT_KEYLENGTH, iv);
        CryptoPP::StreamTransformationFilter* enc = new CryptoPP::StreamTransformationFilter(twofish, base64_enc);
        CryptoPP::Gzip *zip = new CryptoPP::Gzip(enc);
        CryptoPP::StringSource source(spasswd, true, zip);
	}

	return OptUtf8ToStr((CStringA)cipher.c_str());
};


//      AES
CString AuthProcess::DecryptPasswd(const CString &encpasswd, const CString &nameFile)
{
	using namespace std;

	// 
	string spasswd = (string)StrToUtf8(encpasswd);
	string snameFile = (string)StrToUtf8(nameFile);
	
	CryptoPP::Weak::MD5 hash;
	byte hashFile[CryptoPP::Weak::MD5::DIGESTSIZE]; //output size of the buffer
	
	try{
		CryptoPP::FileSource f(snameFile.c_str(), true,
                new CryptoPP::HashFilter(hash,new CryptoPP::ArraySink(hashFile,CryptoPP::Weak::MD5::DIGESTSIZE)));
	}catch(...){
		memset( hashFile, 0x01, CryptoPP::Weak::MD5::DIGESTSIZE );
	}
	// Key and IV setup
    byte key[ CryptoPP::Blowfish::DEFAULT_KEYLENGTH ],iv[ CryptoPP::Blowfish::BLOCKSIZE ];
    // 
	CreateKey( key, CryptoPP::Blowfish::DEFAULT_KEYLENGTH);
	CreateIV(hashFile, CryptoPP::Weak::MD5::DIGESTSIZE, iv, CryptoPP::Blowfish::BLOCKSIZE);

	std::string decipher;
    try {
        CryptoPP::StringSink *sink = new CryptoPP::StringSink(decipher);
        CryptoPP::Gunzip *unzip = new CryptoPP::Gunzip (sink);
        CryptoPP::CBC_Mode<CryptoPP::Blowfish>::Decryption twofish(key, CryptoPP::Blowfish::DEFAULT_KEYLENGTH, iv);
        CryptoPP::StreamTransformationFilter *dec = new CryptoPP::StreamTransformationFilter(twofish, unzip);
        CryptoPP::Base64Decoder *base64_dec = new CryptoPP::Base64Decoder(dec);
        CryptoPP::StringSource source(spasswd, true, base64_dec);
	}catch (...) {
        decipher.clear();
    }

	return OptUtf8ToStr((CStringA)decipher.c_str());
}

//    base64
bool MyBase64Encode(const CString& strIn, CString& strOut)
{
	CBase64Coding Base64Coding;	//    Base64

	// 

	char szTempBuf[1024];
	CT2A szStrInA(strIn);

	//  base64
	if(!Base64Coding.Encode(szStrInA,strIn.GetLength(),szTempBuf))
		return false;

	strOut = szTempBuf;
	return true;
}

UINT AFX_CDECL AuthProcess::OnAuthThread(LPVOID)
{
	CAuthDlg AuthDlg;
	
	if(thePrefs.m_strAuthServ.IsEmpty()
		|| thePrefs.m_strAuthScript.IsEmpty()
		|| thePrefs.m_strAuthLogin.IsEmpty()
		|| thePrefs.m_strAuthPasswd.IsEmpty())
	{
		AfxMessageBox(_T("   "), MB_SYSTEMMODAL);

		theApp.QueueLogLine(true, _T("    (Host:%s Script:%s Login:%s)"),
			thePrefs.m_strAuthServ, thePrefs.m_strAuthScript, thePrefs.m_strAuthLogin);

		if ( AuthDlg.DoModal() != IDOK )
		{
			//    OK
			::PostMessage(theApp.emuledlg->GetSafeHwnd(), WM_COMMAND, MP_DISCONNECT, 0);
			theAuth.m_AuthThread = NULL;
			theAuth.m_AuthStatus = AUTH_NONE;
			return 1;
		}
		else
			thePrefs.SavePreferencesReg();
	}
	
	theApp.QueueLogLine(true, _T(" "));
	theAuth.RequestAuthorization();
	
	//    ,    
	if ( !theApp.serverconnect->IsConnecting() )
		return 0;

	theAuth.ShowResponse();
	
	switch( theAuth.m_AuthResult )
	{
		case AUTH_ERROR:
			if ( theAuth.m_AuthMsgType == ERR_MESSAGE )
			{
				//     
				theApp.QueueLogLine(true, _T("   (Host:%s Script:%s Login:%s)"),
					thePrefs.m_strAuthServ, thePrefs.m_strAuthScript, thePrefs.m_strAuthLogin);
				
				if ( AuthDlg.DoModal() == IDOK ) {
					thePrefs.SavePreferencesReg();
					theAuth.m_AuthStatus = AUTH_NONE;
					theAuth.m_AuthThread = NULL;
					return 0;
				} else {
					::PostMessage(theApp.emuledlg->GetSafeHwnd(), WM_COMMAND, MP_DISCONNECT, 0);
				}
			} else if ( theAuth.m_AuthMsgType == ERR_PROTOCOL ) {
				::PostMessage(theApp.emuledlg->GetSafeHwnd(), WM_COMMAND, MP_DISCONNECT, 0);
			}
			theAuth.m_AuthStatus = AUTH_FAILED;
			break;
		case AUTH_WAIT:
		{
			theAuth.m_AuthStatus = AUTH_WAITING;
			theApp.QueueLogLine(true, _T("  ,     %u ."), theAuth.m_uTimeout);
			HANDLE hEvent = CreateEvent(0,0,0,0);
			WaitForSingleObject(hEvent, theAuth.m_uTimeout*1000);
			theAuth.m_AuthStatus = AUTH_NONE;
			break;
		}
		default:
			theApp.QueueLogLine(true, _T(" "));
			theAuth.m_AuthStatus = AUTH_SUCCESS;
	}

	theAuth.m_AuthThread = NULL;

	return 0;
}

//     
//     
bool AuthProcess::ParseMessage(const char* mess)
{
	TiXmlDocument doc;
	TiXmlElement* xmlElement;
	LPCSTR szElementText;

	doc.Parse(mess);

    TiXmlElement* root = doc.FirstChildElement( "DATA" );
	if(!root)
		return false;

	// m_Result, Timeout
	xmlElement = root->FirstChildElement( "AuthResult" );
	if(!xmlElement)
		return false;
	szElementText = xmlElement->GetText();
	if(szElementText)
		m_AuthResult = static_cast<eAuthResult>(atoi(szElementText));
	else
		m_AuthResult = AUTH_ERROR;

	// Timeout
	if(m_AuthResult == AUTH_WAIT)
	{
		xmlElement = root->FirstChildElement( "Timeout" );
		if(!xmlElement)
			return false;
		szElementText = xmlElement->GetText();
		if(szElementText)
			m_uTimeout = (uint32)atoi(szElementText);
	}

	// m_strMessage, m_MsgType
	xmlElement = root->FirstChildElement( "Message" );
	if(xmlElement){
		szElementText = xmlElement->Attribute("type");
		if(!szElementText){m_AuthMsgType = LOG_MESSAGE;}
		else {
			m_AuthMsgType = static_cast<eAuthMessageType>(atoi(szElementText));
		}

		LPCSTR mess_value = xmlElement->GetText();
		if(mess_value){
			m_strMessage = OptUtf8ToStr((CStringA)mess_value);
		}
	}
	else{
		m_strMessage.Empty();
	}

	/*
    // 
	xmlElement = root->FirstChildElement( "filter" );
	if(xmlElement)
	{
		CStringA strBadWordA;
		LPSTR szBadList = (LPSTR)xmlElement->GetText();
		
		LPCSTR szTokens = ";";
		LPSTR szBadWord = strtok(szBadList, szTokens);

		thePrefs.m_strBadWordsList.RemoveAll();

		while(szBadWord != NULL)
		{
			strBadWordA	= CharLowerA(szBadWord);
			thePrefs.m_strBadWordsList.AddTail(OptUtf8ToStr(strBadWordA));
			szBadWord = strtok(NULL, szTokens);
			
		}
	}
    */

	return true;
};

void AuthProcess::ShowResponse()
{
	if(!m_strMessage.IsEmpty())
	{
		switch(m_AuthMsgType)
		{
			case LOG_MESSAGE:
				theApp.QueueLogLine(true,L"  : %s",m_strMessage);
				break;
			case INFO_MESSAGE_NOMODAL:
				MessageBox(0,m_strMessage,L"",MB_OK | MB_ICONINFORMATION);
				theApp.QueueLogLine(true,L"  : " + m_strMessage);
				break;
			case INFO_MESSAGE_MODAL:
				theApp.emuledlg->activewnd->MessageBox(m_strMessage,L"",MB_OK | MB_ICONINFORMATION);
				theApp.QueueLogLine(true,L"  : " + m_strMessage);
				break;
			case ERR_MESSAGE:
				theApp.emuledlg->activewnd->MessageBox(m_strMessage,L"",MB_OK | MB_ICONERROR);
				theApp.QueueLogLine(true,L"  : " + m_strMessage);
				break;
			case WARN_PROTOCOL:
				theApp.QueueLogLine(true,L"  : " + m_strMessage);
				break;
			case ERR_PROTOCOL:
				theApp.QueueLogLine(true,L"  : " + m_strMessage);
                theApp.emuledlg->activewnd->MessageBox(m_strMessage,L"",MB_OK | MB_ICONERROR);
				break;
			default:
				theApp.QueueLogLine(true,L"  ");
		}
	}
}

void AuthProcess::SetResponse( LPCTSTR szMessage, eAuthResult res, eAuthMessageType type )
{
	m_strMessage = szMessage;
	m_AuthResult = res;
	m_AuthMsgType = type;
}

// 
CStringA AuthProcess::CreateQuery()
{
	CString tmp;
	CString request_;
	request_ = L"/" + thePrefs.m_strAuthScript + L"?";
	if(MyBase64Encode(thePrefs.m_strAuthLogin, tmp)){
		request_.Append(L"login=" + tmp);
	}else{
		request_.Append(L"login=''");
		theApp.QueueLogLine(true, L"   ");
	}

	if(MyBase64Encode(thePrefs.m_strAuthPasswd, tmp)){
		request_.Append(L"&password=" + tmp);
	}else{
		request_.Append(L"&password=''");
		theApp.QueueLogLine(true, L"   ");
	}

	if(MyBase64Encode(thePrefs.strNick, tmp)){
		request_.Append(L"&nick=" + tmp);
	}else{
		request_.Append(L"&nick=''");
		theApp.QueueLogLine(true, L"   ");
	}
	
	// 
	CString version;
	version.Format(L"%u.%u.%u", IS_VERSION_MJR, IS_VERSION_MIN, IS_VERSION_UPDATE);

	#ifdef IS_VERSION_ALPHA
		version.AppendFormat(L".%u", IS_VERSION_ALPHA);
	#else
		version.AppendFormat(L".%u", 0);
	#endif

	#ifdef IS_VERSION_BETA
		version.AppendFormat(L".%u", IS_VERSION_BETA);
	#else
		version.AppendFormat(L".%u", 0);
	#endif

	if(MyBase64Encode(version, tmp)){
		request_.Append(L"&version=" + tmp);
	}else{
		request_.Append(L"&version=''");
		theApp.QueueLogLine(true, L"   ");
	}

	return (CStringA)request_;
}

//        
uint32 Resolve( LPCSTR szHost )
{
	uint32 ret = NULL;
	//This structure should never be released!
	struct hostent * hp = gethostbyname(szHost);
	if (!hp)
	{
		ret = inet_addr(szHost);
	}
	if ((!hp)&&(ret == INADDR_NONE))
	{
		return NULL;
	}
	if (hp != NULL)
	{
		memcpy((void*)&ret, hp->h_addr, hp->h_length);
	}
	return ret;
}

//   
void AuthProcess::RequestAuthorization()
{
	CStringA strHeadersA;
	CString strErrMsg;
    
	//  ssl
	const SSL_METHOD *method;
	SSL_CTX *ctx;
	
	if((method = SSLv2_client_method()) == NULL)
	{
		strErrMsg.Format(_T("  SSL  .   (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, LOG_MESSAGE);
		return;
	}
	if((ctx = SSL_CTX_new(method)) == NULL)
	{
		strErrMsg.Format(_T("   SSL  .   (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, LOG_MESSAGE);
		return;
	}

	SOCKET sock;
	struct sockaddr_in addr;

	sock = socket(PF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET)
	{
		SetResponse(_T("      ."), AUTH_ERROR, LOG_MESSAGE);
		SSL_CTX_free(ctx);
		return;
	}

	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(443);
	addr.sin_addr.s_addr = Resolve(CT2CA(thePrefs.m_strAuthServ));

	if(addr.sin_addr.s_addr == NULL)
	{
		SetResponse(_T("  IP-  ."), AUTH_ERROR, LOG_MESSAGE);
		SSL_CTX_free(ctx);
		return;
	}

	if(connect(sock, (struct sockaddr*)&addr, sizeof(addr)) == SOCKET_ERROR)
	{
		SetResponse(_T("     ."), AUTH_ERROR, LOG_MESSAGE);
		SSL_CTX_free(ctx);
		return;
	}

	SSL *ssl;
	if((ssl = SSL_new(ctx)) == NULL)
	{
		strErrMsg.Format(_T("  SSL      . (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, LOG_MESSAGE);
		SSL_CTX_free(ctx);
		closesocket(sock);
		return;
	}

	if(SSL_set_fd(ssl, sock) == 0)
	{
		strErrMsg.Format(_T("   SSL     . (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, LOG_MESSAGE);
		SSL_free(ssl);
		SSL_CTX_free(ctx);
		closesocket(sock);
		return;
	}

	if(SSL_connect(ssl) != 1)
	{
		strErrMsg.Format(_T("    . (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, WARN_PROTOCOL);
		SSL_free(ssl);
		SSL_CTX_free(ctx);
		closesocket(sock);
		return;
	}
	
	CStringA strQuery = CreateQuery(); 
	//  
	strHeadersA.Format(
		"GET %s HTTP/1.1\r\n"
		"User-Agent: eMule ISMod\r\n"
		"Host: %s\r\n"
		"Accept: text/html, application/xml;q=0.9, */*;q=0.1\r\n"
		"Accept-Language: ru,en;q=0.9\r\n"
		"Accept-Charset: utf-8, *;q=0.1\r\n"
		"Cache-Control: no-cache\r\n"
		"Connection: Close\r\n\r\n",
		strQuery, CT2A(thePrefs.m_strAuthServ));
	
	if(SSL_write(ssl, (LPCSTR)strHeadersA, strHeadersA.GetLength()) <= 0)
	{
		strErrMsg.Format(_T("     . (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
		SetResponse(strErrMsg, AUTH_ERROR, WARN_PROTOCOL);
		SSL_free(ssl);
		SSL_CTX_free(ctx);
		closesocket(sock);
		return;
	}
	
	CStringA strAnswer;
	int iLen = 0;
	do
	{
		char szData[4096];//4     
		iLen = SSL_read(ssl, szData, _countof(szData)-1);
		if(iLen > 0)
		{
			szData[iLen] = '\0';
			strAnswer += szData;
		}else if(SSL_get_error(ssl, iLen) == SSL_ERROR_ZERO_RETURN)
			break; // ,  
		else
		{
			strErrMsg.Format(_T("      . (%s)"), CA2T(ERR_error_string(ERR_get_error(), NULL)));
			SetResponse(strErrMsg, AUTH_ERROR, WARN_PROTOCOL);
			SSL_free(ssl);
			SSL_CTX_free(ctx);
			closesocket(sock);
			return;
		}

	}while(iLen != 0);
	
	SSL_free(ssl);
	SSL_CTX_free(ctx);
	closesocket(sock);

	//  
	//strAnswer = "<?xml version=\"1.0\"><DATA><AuthResult>1</AuthResult><Message type=3><![CDATA[привет засранцы чортовы]]></Message></DATA>";
	ParseMessage(strAnswer.Mid(strAnswer.Find("\r\n\r\n")+4)); //     
}

void AuthProcess::StartAuth()
{
	if(m_AuthStatus == AUTH_STARTED || m_AuthStatus == AUTH_WAITING)
		return;

	m_AuthThread = AfxBeginThread(OnAuthThread, 0);
	if(m_AuthThread)
	{
		m_AuthStatus = AUTH_STARTED;
		return;
	}
	m_AuthStatus = AUTH_NONE;
}	

void AuthProcess::StopAuth()
{
    m_AuthStatus = AUTH_NONE;
    m_AuthResult = AUTH_ERROR;
    m_uTimeout = 0;
}

AuthProcess::AuthProcess()
{
	m_AuthStatus = AUTH_NONE;
	m_AuthResult = AUTH_ERROR;
	m_uTimeout = 0;
}