//this file is part of eMule IS Mod
//Copyright (C)2009 IS Mod Team
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

class CHashArray
{
public:
	CHashArray(uint32 hashSize = 16)
	{
		m_data = NULL;
		m_count = 0;
		m_hashSize = hashSize;
	}
	~CHashArray() { release(); }

	uint32	hashSize() const { return m_hashSize; }
	uint32	count() const { return m_count; }
	void	forceCount(uint32 count) { m_count = count; }
	bool	empty() const { return count()==0; }
	uchar*	data() const { return m_data; }
	void	append(const uchar* hash) { memcpy(m_data+m_count*m_hashSize, hash, m_hashSize); }
	uchar*	append_v() { return m_data + m_count++ * m_hashSize; }
	void	allocate(uint32 count) {
		release();
		m_data = new uchar[count*m_hashSize];
	}

	void release() {
		if ( m_data )
			delete[] m_data;
		m_data = NULL;
		m_count = 0;
	}

	void copy(const CHashArray &hasharray){
		m_hashSize = hasharray.hashSize();
		allocate(hasharray.count());
		m_count = hasharray.count();
		memcpy(m_data, hasharray.data(), m_count*m_hashSize);
	}

	const uchar* operator[](int index) const { return m_data+index*m_hashSize; }

private:
	uchar *m_data;
	uint32 m_count;
	uint32 m_hashSize;
};
