//this file is part of eMule
//Copyright (C)2002-2008 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "resource.h"
#include "eMule.h"
#include "InputBox.h"
#include "OtherFunctions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNAMIC(InputBox, CDialog)

BEGIN_MESSAGE_MAP(InputBox, CDialog)
	ON_BN_CLICKED(IDC_CLEANFILENAME, OnCleanFilename)
	// ismod
	ON_BN_CLICKED(IDC_MOD_RADIO_BEGIN, OnBnClickedRadioBegin)
	ON_BN_CLICKED(IDC_MOD_RADIO_END, OnBnClickedRadioEnd)
END_MESSAGE_MAP()

InputBox::InputBox(CWnd* pParent /*=NULL*/)
	: CDialog(InputBox::IDD, pParent)
{
	m_cancel = true;
	m_bFilenameMode = false;
	m_icMain = NULL;

	// ismod
	m_fileCount = 1;
	m_strBegin = _T("");
	m_strEnd = _T("");
	m_renameMode = 0;	//simple rename
}

InputBox::~InputBox()
{
	if (m_icMain)
		VERIFY( DestroyIcon(m_icMain) );
}

void InputBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

void InputBox::OnOK()
{
	m_cancel = false;
	GetDlgItemText(IDC_TEXT, m_return);
	/* ismod
	m_return.Trim();
	*/
	if (!m_renameMode)
	{
		m_return.Trim();
	}
	CDialog::OnOK();
}

void InputBox::SetLabels(CString title, CString label, CString defaultStr)
{
	m_label = label;
	m_title = title;
	m_default = defaultStr;
}

// ismod
void InputBox::SetBehavior(uint32 filecount, CString strBegin, CString strEnd)
{
	m_fileCount = filecount;
	m_strBegin = strBegin;
	m_strEnd = strEnd;
}

BOOL InputBox::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitWindowStyles(this);
	SetIcon( m_icMain = theApp.LoadIcon(_T("RENAME")),FALSE);

	GetDlgItem(IDC_IBLABEL)->SetWindowText(m_label);
	GetDlgItem(IDC_TEXT)->SetWindowText(m_default);
	SetWindowText(m_title);

	SetDlgItemText(IDOK, GetResString(IDS_TREEOPTIONS_OK) );
	GetDlgItem(IDCANCEL)->SetWindowText(GetResString(IDS_CANCEL));
	SetDlgItemText(IDC_CLEANFILENAME,GetResString(IDS_CLEANUP));
	GetDlgItem(IDC_CLEANFILENAME)->ShowWindow(m_bFilenameMode ? SW_NORMAL : SW_HIDE);

	// ismod [start]
	if (m_fileCount == 1)
	{
		GetDlgItem(IDC_MOD_RADIO_BEGIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOD_RADIO_END)->EnableWindow(FALSE);
		CheckDlgButton(IDC_MOD_RADIO_RENAME, BST_CHECKED);
	}
	else
	{
		m_label = _T(" ");
		GetDlgItem(IDC_IBLABEL)->SetWindowText(m_label);
		GetDlgItem(IDC_MOD_RADIO_RENAME)->EnableWindow(FALSE);
		CheckDlgButton(IDC_MOD_RADIO_BEGIN, BST_CHECKED);
		OnBnClickedRadioBegin();
	}
	// ismod [end]
	return TRUE;
}

void InputBox::OnCleanFilename()
{
	CString filename;
	GetDlgItem(IDC_TEXT)->GetWindowText(filename);
	GetDlgItem(IDC_TEXT)->SetWindowText(CleanupFilename(filename));
}

// ismod [start]
void InputBox::OnBnClickedRadioBegin()
{
	m_default = m_strBegin;
	GetDlgItem(IDC_TEXT)->SetWindowText(m_default);
	//GetDlgItem(IDC_RADIO_RENAME)->ShowWindow(SW_NORMAL);
	//GetDlgItem(IDC_RADIO_END)->ShowWindow(SW_NORMAL);
	m_renameMode = 1;	//from beginning
}

void InputBox::OnBnClickedRadioEnd()
{
	m_default = m_strEnd;
	GetDlgItem(IDC_TEXT)->SetWindowText(m_default);
	//GetDlgItem(IDC_RADIO_RENAME)->ShowWindow(SW_NORMAL);
	//GetDlgItem(IDC_RADIO_BEGIN)->ShowWindow(SW_NORMAL);
	m_renameMode = 2;	//from end
}
