//this file is part of eMule IS Mod
//Copyright (C)2009 eMule IS Mod
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "sctCore.h"
#include "SctWnd.h"
#include "resource.h"
#include "SctWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Sct dialog

IMPLEMENT_DYNAMIC(CSctWnd, CDialog)

BEGIN_MESSAGE_MAP(CSctWnd, CResizableDialog)
    ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_IS74_SETTINGS_HELP, OnBnClickedSettings)
	ON_BN_CLICKED(IDC_BUTTON_IS74_PAYMENT_HELP, OnBnClickedPayment)
    ON_BN_CLICKED(IDC_CHECK_AUTO_UPDATE, &CSctWnd::OnBnClickedCheckAutoUpdate)
    ON_BN_CLICKED(IDC_CHECK_DISABLE_SCT, &CSctWnd::OnBnClickedCheckDisableSct)
END_MESSAGE_MAP()

CSctWnd::CSctWnd(CWnd* pParent /*=NULL*/)
    : CResizableDialog(CSctWnd::IDD, pParent),
    m_sctCore( new CSctCore )
{

}

CSctWnd::~CSctWnd()
{
    delete m_sctCore;
}

BOOL CSctWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	RefreshInfo();

    // set initial states
    CheckDlgButton(IDC_CHECK_AUTO_UPDATE, m_sctCore->m_bAutoUpdate);
    CheckDlgButton(IDC_CHECK_DISABLE_SCT, m_sctCore->m_bSctDisabled);

	// init UI anchors
    AddAnchor(IDC_GROUP_TEST, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_GROUP_INFO, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_GROUP_DEBUG, TOP_LEFT, TOP_RIGHT);
    AddAnchor(IDC_STATIC_ETHERNET, TOP_LEFT, TOP_RIGHT);
    AddAnchor(IDC_STATIC_IS74RU, TOP_LEFT, TOP_RIGHT);
    AddAnchor(IDC_PROGRESS_ETHERNET, TOP_RIGHT, TOP_RIGHT);
    AddAnchor(IDC_PROGRESS_IS74RU, TOP_RIGHT, TOP_RIGHT);
    AddAnchor(IDC_LIST_DEBUG_LOG, TOP_LEFT, TOP_RIGHT);

//    
#ifndef DEBUG
    GetDlgItem(IDC_BUTTON_GET_TASK)->ShowWindow(SW_HIDE);
    GetDlgItem(IDC_CHECK_DISABLE_SCT)->ShowWindow(SW_HIDE);
    GetDlgItem(IDC_GROUP_DEBUG)->ShowWindow(SW_HIDE);
    GetDlgItem(IDC_LIST_DEBUG_LOG)->ShowWindow(SW_HIDE);
#endif

	return true;
}

void CSctWnd::OnDestroy()
{
}

void CSctWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_PROGRESS_ETHERNET, progress_ethernet);
	DDX_Control(pDX, IDC_PROGRESS_IS74RU, progress_is74ru);
	DDX_Control(pDX, IDC_STATIC_ETHERNET, static_ethernet);
	DDX_Control(pDX, IDC_STATIC_IS74RU, static_is74ru);
    DDX_Control(pDX, IDC_LIST_DEBUG_LOG, m_DebugLog);
}

LRESULT CSctWnd::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		// arrange transferwindow layout
		case WM_PAINT:
			RefreshInfo();
			break;
	}

	return CResizableDialog::DefWindowProc(message, wParam, lParam);
}

//    
void CSctWnd::OnBnClickedSettings()
{
    ShellExecute(0, _T("open"), _T("http://is74.ru/support/instructions/"), _T(""), NULL, SW_SHOW);
}

//   
void CSctWnd::OnBnClickedPayment()
{
    ShellExecute(0, _T("open"), _T("http://is74.ru/support/payment/"), _T(""), NULL, SW_SHOW);
}

void CSctWnd::RefreshInfo()
{
    progress_ethernet.SetRange32(0, 100);
	progress_ethernet.SetStep(1);
	progress_ethernet.SetPos(m_sctCore->GetEthernetStatus());
	
    if (m_sctCore->GetEthernetStatus() <= 0)
        static_ethernet.SetWindowText(_T(""));
    else
    {
        CString strMsg;
        strMsg.Format(
            _T("IP: %s, DHCP Server: %s"),
            m_sctCore->GetOwnIp(),
            m_sctCore->GetDhcpIp());
        static_ethernet.SetWindowText(strMsg);
    }
    
    progress_is74ru.SetRange32(0, 100);
	progress_is74ru.SetStep(1);
	progress_is74ru.SetPos(m_sctCore->GetIs74SiteStatus());
	
	if ( m_sctCore->GetIs74SiteStatus() <= 0 )
        static_is74ru.SetWindowText(_T(""));
	else
        static_is74ru.SetWindowText(_T(""));
}

void CSctWnd::CreateWnd()
{
    CResizableDialog::Create(IDD_SCT);
}

void CSctWnd::setAuthPtrs( const CString* strAuthLogin, const CString* strAuthPassword )
{
    m_sctCore->m_strLogin = strAuthLogin;
    m_sctCore->m_strPassword = strAuthPassword;
    m_sctCore->startThreads();
}

void CSctWnd::OnBnClickedCheckAutoUpdate()
{
    m_sctCore->m_bAutoUpdate = (IsDlgButtonChecked(IDC_CHECK_AUTO_UPDATE) != 0);
}

void CSctWnd::OnBnClickedCheckDisableSct()
{
    m_sctCore->m_bSctDisabled = (IsDlgButtonChecked(IDC_CHECK_DISABLE_SCT) != 0);
}