//this file is part of eMule IS Mod
//Copyright (C)2009 eMule IS Mod
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef _SCTCORE_H_
#define _SCTCORE_H_

#pragma once;

#include <vector>

class CSctCore
{
    enum ETaskType
    {
        SCT_TASK_PING=1,	//     ICMP
        SCT_TASK_TELE,		//     
		SCT_TASK_VIDEO
    };

    struct ICMP_TEST_RESULT
    {
        uint32 uMin;
        uint32 uMax;
        uint32 uMid;
        uint8  uTtl;
    };

public:
    // 
    CSctCore();

    // 
    virtual ~CSctCore();

    void startThreads();
    
    inline bool IsEnabled() const { return !m_bSctDisabled; }
    inline const CString& GetOwnIp() const { return m_strDhcpIpAddr; }
    inline const CString& GetDhcpIp() const { return m_strDhcpServer; }
    inline uint8 GetEthernetStatus() const { return m_uEthernetStatus; }
    inline uint8 GetIs74SiteStatus() const { return m_uConnectionStatusToIs74ru; }

	//  
	void execTask( const CString& hash, const CString& taskData );

    //      ,      
    const CString *m_strLogin;
    const CString *m_strPassword;

    bool m_bSctDisabled; //   
    bool m_bAutoUpdate; //    

private:

    //     
    static UINT AFX_CDECL clientThread( LPVOID lpParam );
    static UINT AFX_CDECL serverThread( LPVOID lpParam );

    double CalculateBandwidth( LPCTSTR szUrl ) const;
	uint8 CheckTcpConnection( LPCTSTR szHost, uint16 uPort, uint32 uCount ) const;
    uint8 CheckUdpConnection( LPCTSTR szHost, uint16 uPort, uint32 uCount ) const;	
    uint8 CheckIcmpConnection( LPCTSTR szHost, uint16 uDataSize, uint32 uRepeatInterval, uint32 uRepeadCount, ICMP_TEST_RESULT& itr ) const;
    CString execIcmpCheckOthers( const CString& params ) const;
	CString execTestVideoServer( const CString& params ) const;
    bool runSelfUpdate( LPCTSTR szUpdateLink ) const;
    void LoadSettings();
    void SaveSettings() const;

    //     tcp://is74.ru:80,  
    uint8 m_uConnectionStatusToIs74ru; // -    ,  

    //      ,  
    uint8 m_uEthernetStatus;

    CString m_strDhcpIpAddr;      // ip-  dhcp
    CString m_strDhcpServer;      // ip- dhcp 
	uint32  m_uDelay;             //  ()     
    HMODULE m_hIcmpDll;           //      icmp
    HANDLE m_hWaitEvent;            //   
    bool m_bAlreadyUpdated;
    CRITICAL_SECTION m_updateServersCS;
    std::vector<ULONG> m_serverIps;

    CWinThread *m_clientThread;
    CWinThread *m_serverThread;
};

#endif // #ifndef _SCTCORE_H_
